vigra - NeighborCode3D Class Reference

[ VIGRA Homepage | Function Index | Class Index | Namespaces | File List | Main Page ]

| NeighborCode3D Class Reference |

Encapsulation of direction management of neighbors for a 3D 26-neighborhood. More...

`#include <vigra/voxelneighborhood.hxx>`

## Public Types
enum | Direction

## Static Public Member Functions
static Diff3D const & | behind ()
static Diff3D const & | behindEast ()
static Diff3D const & | behindNorth ()
static Diff3D const & | behindNorthEast ()
static Diff3D const & | behindNorthWest ()
static Diff3D const & | behindSouth ()
static Diff3D const & | behindSouthEast ()
static Diff3D const & | behindSouthWest ()
static Diff3D const & | behindWest ()
static Diff3D const & | bottom ()
static Diff3D const & | bottomLeft ()
static Diff3D const & | bottomRight ()
static Direction | code (Neighborhood3DSix::Direction d)
static Direction | code (Diff3D const &diff)
static Diff3D const & | diff (Direction code)
static Diff3D const & | diff (int code)
static int | diff (Direction code, int dim)
static int | dX (Direction code)
static int | dX (int code)
static int | dY (Direction code)
static int | dY (int code)
static int | dZ (Direction code)
static int | dZ (int code)
static Diff3D const & | east ()
static Diff3D const & | front ()
static Diff3D const & | frontBottom ()
static Diff3D const & | frontBottomLeft ()
static Diff3D const & | frontBottomRight ()
static Diff3D const & | frontLeft ()
static Diff3D const & | frontRight ()
static Diff3D const & | frontTop ()
static Diff3D const & | frontTopLeft ()
static Diff3D const & | frontTopRight ()
static Diff3D const & | infront ()
static Diff3D const & | infrontEast ()
static Diff3D const & | infrontNorth ()
static Diff3D const & | infrontNorthEast ()
static Diff3D const & | infrontNorthWest ()
static Diff3D const & | infrontSouth ()
static Diff3D const & | infrontSouthEast ()
static Diff3D const & | infrontSouthWest ()
static Diff3D const & | infrontWest ()
static bool | isDiagonal (Direction dir)
static Diff3D const & | left ()
static unsigned int | nearBorderDirectionCount (AtVolumeBorder b)
static Direction | nearBorderDirections (AtVolumeBorder b, int index)
static Direction | nearBorderDirectionsCausal (AtVolumeBorder b, int index)
static Diff3D const & | north ()
static Diff3D const & | northEast ()
static Diff3D const & | northWest ()
static Diff3D const & | rear ()
static Diff3D const & | rearBottom ()
static Diff3D const & | rearBottomLeft ()
static Diff3D const & | rearBottomRight ()
static Diff3D const & | rearLeft ()
static Diff3D const & | rearRight ()
static Diff3D const & | rearTop ()
static Diff3D const & | rearTopLeft ()
static Diff3D const & | rearTopRight ()
static Diff3D const | relativeDiff (Direction fromCode, Direction toCode)
static Diff3D const | relativeDiff (int fromCode, int toCode)
static Diff3D const & | right ()
static Diff3D const & | south ()
static Diff3D const & | southEast ()
static Diff3D const & | southWest ()
static Diff3D const & | top ()
static Diff3D const & | topLeft ()
static Diff3D const & | topRight ()
static Diff3D const & | west ()

## Detailed Description

Encapsulation of direction management of neighbors for a 3D 26-neighborhood.

## Member Enumeration Documentation

enum Direction

provides enumeration of all directions. DirectionCount may be used for portable loop termination conditions.

## Member Function Documentation

static unsigned int nearBorderDirectionCount | ( | AtVolumeBorder | b | ) |
| static

The number of valid neighbors if the current center is at the volume border.

static Direction nearBorderDirections | ( | AtVolumeBorder | b,
|  | int | index
| ) |  |
| static

The valid direction codes when the center is at the volume border. index must be in the range `0...nearBorderDirectionCount(b)-1`.

static Direction nearBorderDirectionsCausal | ( | AtVolumeBorder | b,
|  | int | index
| ) |  |
| static

The valid direction three codes in anti causal direction (means: look back in scanline direction)when the center is at the volume border. Should be used with isAtVolumeBorderCausal to determine the Directions, as this avoids using of the nonesense border ids (e.g. 0,1,8,9...) of this table. index must be in the range `0...nearBorderDirectionCount(b)-1`.

static Diff3D const& diff | ( | Direction | code | ) |
| static

transform direction code into corresponding Diff3D offset. (note: there is no bounds checking on the code you pass.)

static Diff3D const& diff | ( | int | code | ) |
| static

Equivalent to `diff(static_cast<Direction>(code))`. (note: there is no bounds checking on the code you pass.)

static int diff | ( | Direction | code,
|  | int | dim
| ) |  |
| static

Equivalent to `diff(code)[dim]`

static Diff3D const relativeDiff | ( | Direction | fromCode,
|  | Direction | toCode
| ) |  |
| static

    Get the relative offset from one neighbor to the other.

For example, `relativeDiff(East, West) == multi_differencetype(-2,0,0)`. (note: there is no bounds checking on the code you pass.)

static Diff3D const relativeDiff | ( | int | fromCode,
|  | int | toCode
| ) |  |
| static

Equivalent to relativeDiff(static_cast<Direction>(fromCode), static_cast<Direction>(toCode)). (note: there is no bounds checking on the code you pass.)

static int dX | ( | Direction | code | ) |
| static

X-component of diff()

static int dY | ( | Direction | code | ) |
| static

Y-component of diff()

static int dZ | ( | Direction | code | ) |
| static

Z-component of diff()

static int dX | ( | int | code | ) |
| static

X-component of diff()

static int dY | ( | int | code | ) |
| static

Y-component of diff()

static int dZ | ( | int | code | ) |
| static

Z-component of diff()

static Direction code | ( | Neighborhood3DSix::Direction | d | ) |
| static

transform 6-neighborhood code into 26-neighborhood code.

static Direction code | ( | Diff3D const & | diff | ) |
| static

transform Diff3D offset into corresponding direction code. The code `Direction::Error` will be returned if `diff` is not in the 3DTwentySix-Neighborhood.

static bool isDiagonal | ( | Direction | dir | ) |
| static

Check whether a code refers to a diagonal direction. Useful if you want to abstract the differences between 6- and 26-neighborhood. Always `false` for 6-neighborhood.

static Diff3D const& frontTopLeft | ( |  | ) |
| static

Offset to the front-top-left neighbor

static Diff3D const& frontTop | ( |  | ) |
| static

Offset to the front-top neighbor

static Diff3D const& frontTopRight | ( |  | ) |
| static

Offset to the front-top-right neighbor

static Diff3D const& frontLeft | ( |  | ) |
| static

Offset to the front-left neighbor

static Diff3D const& front | ( |  | ) |
| static

Offset to the front neighbor

static Diff3D const& frontRight | ( |  | ) |
| static

Offset to the front-right neighbor

static Diff3D const& frontBottomLeft | ( |  | ) |
| static

Offset to the front-bottom-left neighbor

static Diff3D const& frontBottom | ( |  | ) |
| static

Offset to the front-bottom neighbor

static Diff3D const& frontBottomRight | ( |  | ) |
| static

Offset to the front-bottom-right neighbor

static Diff3D const& topLeft | ( |  | ) |
| static

Offset to the top-left neighbor

static Diff3D const& top | ( |  | ) |
| static

Offset to the top neighbor

static Diff3D const& topRight | ( |  | ) |
| static

Offset to the top-right neighbor

static Diff3D const& left | ( |  | ) |
| static

Offset to the left neighbor

static Diff3D const& right | ( |  | ) |
| static

Offset to the right neighbor

static Diff3D const& bottomLeft | ( |  | ) |
| static

Offset to the bottom-left neighbor

static Diff3D const& bottom | ( |  | ) |
| static

Offset to the bottom neighbor

static Diff3D const& bottomRight | ( |  | ) |
| static

Offset to the bottom-right neighbor

static Diff3D const& rearTopLeft | ( |  | ) |
| static

Offset to the rear-top-left neighbor

static Diff3D const& rearTop | ( |  | ) |
| static

Offset to the rear-top neighbor

static Diff3D const& rearTopRight | ( |  | ) |
| static

Offset to the rear-top-right neighbor

static Diff3D const& rearLeft | ( |  | ) |
| static

Offset to the rear-left neighbor

static Diff3D const& rear | ( |  | ) |
| static

Offset to the rear neighbor

static Diff3D const& rearRight | ( |  | ) |
| static

Offset to the rear-right neighbor

static Diff3D const& rearBottomLeft | ( |  | ) |
| static

Offset to the rear-bottom-left neighbor

static Diff3D const& rearBottom | ( |  | ) |
| static

Offset to the rear-bottom neighbor

static Diff3D const& rearBottomRight | ( |  | ) |
| static

Offset to the rear-bottom-right neighbor

static Diff3D const& infrontNorthWest | ( |  | ) |
| static

Offset to the infront-north-west neighbor

static Diff3D const& infrontNorth | ( |  | ) |
| static

Offset to the infront-north neighbor

static Diff3D const& infrontNorthEast | ( |  | ) |
| static

Offset to the infront-north-east neighbor

static Diff3D const& infrontWest | ( |  | ) |
| static

Offset to the infront-west neighbor

static Diff3D const& infront | ( |  | ) |
| static

Offset to the infront neighbor

static Diff3D const& infrontEast | ( |  | ) |
| static

Offset to the infront-east neighbor

static Diff3D const& infrontSouthWest | ( |  | ) |
| static

Offset to the infront-south-west neighbor

static Diff3D const& infrontSouth | ( |  | ) |
| static

Offset to the infront-south neighbor

static Diff3D const& infrontSouthEast | ( |  | ) |
| static

Offset to the infront-south-east neighbor

static Diff3D const& northWest | ( |  | ) |
| static

Offset to the north-west neighbor

static Diff3D const& north | ( |  | ) |
| static

Offset to the north neighbor

static Diff3D const& northEast | ( |  | ) |
| static

Offset to the north-east neighbor

static Diff3D const& west | ( |  | ) |
| static

Offset to the west neighbor

static Diff3D const& east | ( |  | ) |
| static

Offset to the right neighbor

static Diff3D const& southWest | ( |  | ) |
| static

Offset to the south-west neighbor

static Diff3D const& south | ( |  | ) |
| static

Offset to the south neighbor

static Diff3D const& southEast | ( |  | ) |
| static

Offset to the south-east neighbor

static Diff3D const& behindNorthWest | ( |  | ) |
| static

Offset to the behind-north-west neighbor

static Diff3D const& behindNorth | ( |  | ) |
| static

Offset to the behind-north neighbor

static Diff3D const& behindNorthEast | ( |  | ) |
| static

Offset to the behind-north-east neighbor

static Diff3D const& behindEast | ( |  | ) |
| static

Offset to the behind-west neighbor

static Diff3D const& behind | ( |  | ) |
| static

Offset to the behind neighbor

static Diff3D const& behindWest | ( |  | ) |
| static

Offset to the behind-right neighbor

static Diff3D const& behindSouthWest | ( |  | ) |
| static

Offset to the behind-south-west neighbor

static Diff3D const& behindSouth | ( |  | ) |
| static

Offset to the behind-south neighbor

static Diff3D const& behindSouthEast | ( |  | ) |
| static

Offset to the behind-south-east neighbor

The documentation for this class was generated from the following file:

- vigra/voxelneighborhood.hxx

© Ullrich Köthe (ullrich.koethe@iwr.uni-heidelberg.de) Heidelberg Collaboratory for Image Processing, University of Heidelberg, Germany | html generated using doxygen and Python vigra 1.10.0 (Mon Nov 18 2013)